<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_Rating extends Controller_Handler
{
    /** @var  Model_Rating */
    protected $model;

    public function before() {
        parent::before();

        $this->user->checkAccess(User::RIGHTS_TEACHER);
        $this->model = new Model_Rating;
    }

    public function action_SetRate() {
        $this->post
            ->rule('studentID', 'digit')
            ->rule('disciplineID', 'digit')
            ->rule('submoduleID', 'digit')
            ->rule('rate', 'numeric')
            ->rule('rate', 'range', [':value', -1, 100]);
        if (!$this->post->check()) HTTP_API_Exception::factory(400, null);

        $errorMsg = Model_Rating::SetRate(
            $this->user->TeacherID,
            $_POST['studentID'],
            $_POST['disciplineID'],
            $_POST['submoduleID'],
            $_POST['rate']
        );
        if (!is_null($errorMsg)) throw HTTP_API_Exception::factory(400, $errorMsg);

        $this->response->body(json_encode([ success => true ]));
    }

    public function action_SetExamPeriodOption() {
        $errorMsg = null;

        $this->post
            ->rule('studentID', 'digit')
            ->rule('disciplineID', 'digit')
            ->rule('submoduleID', 'digit')
            ->rule('option', 'in_array', array(':value', array('null', 'absence', 'pass')));
        if (!$this->post->check()) HTTP_API_Exception::factory(400, null);

        $errorMsg = Model_Rating::SetExamPeriodOption(
            $this->user->TeacherID,
            $_POST['studentID'],
            $_POST['disciplineID'],
            $_POST['submoduleID'],
            $_POST['option']
        );
        if (!is_null($errorMsg)) throw HTTP_API_Exception::factory(400, $errorMsg);

        $this->response->body(json_encode([ success => true ]));
    }
}
